
/*
 * -*- mode: C; tab-width:8;  -*-
 * 
 *	aclTriangle.c -
 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * See the file aclMesa.c for more informations about authors
 */



#if defined(ACL)

#include "aclDrv.h"



#if 0
#define LOG_DEBUG
#endif

#define LOG_DBGINFO "<aclTriangle>"
#include "log_debug.h"



static void
aclTriangleDraw(GLcontext *ctx,
	GLuint v1, GLuint v2, GLuint v3, GLuint pv)
{
    ACLMesaContext aclMesa = (ACLMesaContext) ctx->DriverCtx;
LOG("aclTriangleDraw(): ######\n");

    aclMesa->aclaccel_mod->Triangle(aclMesa->aclctx, &(aclMesa->vb_pointers),
	v1, v2, v3, pv);
}



static void
aclTriangleDrawFrontBack(GLcontext *ctx,
	GLuint v1, GLuint v2, GLuint v3, GLuint pv)
{
}



triangle_func
aclTriangleChooseFunction(GLcontext *ctx)
{
    ACLMesaContext aclMesa = (ACLMesaContext) ctx->DriverCtx;

LOG("aclTriangleChooseFunction():  ######\n");

    if(aclMesa->no_primitive & ACLPRIM_TRIANGLE)
	return NULL;

    if(ctx->RasterMask & FRONT_AND_BACK_BIT) {
	return aclTriangleDrawFrontBack;
    }
    return aclTriangleDraw;
}



#else

int aclTriangle_dummy(void) { return 0; }

#endif /* ACL */

